; ==========================
; TrueCalc
; ==========================

; A very nice little virus that gets rid of any asm program without a special
; key set.  This key is a $CE in the 9th byte of the program.

; Of course, if the program disables alt_int, the routine will probably be
; deactivated before it can catch the program, but most program do not do this,
; so it should work alright in most cases.

; By Mark Shroyer.
; December 23, 1999.


#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp Prog_start
	.dw 0
	.dw FileID

	.db $CE		; Added as the key that my routine looks for, to keep it from
				; getting rid of THIS program...

FileID:
	.db "Generic alt_int template: TrueCalc",0

Static_installed:
	.db "Installed, activated."
	.db "TrueCalc v1.0        ",0

Static_deactivated:
	.db "Routine deactivated. ",0

Prog_start:
	call _newline

	bit alt_int,(iy+exceptionflg)
	jr z,Prog_install

	res alt_int,(iy+exceptionflg)
	ld hl,Static_deactivated
	jp _puts

Prog_install:
	ld hl,Routine_Location
	ld de,_alt_interrupt_exec
	ld bc,Routine_End-Routine_Start
	ldir

	ld de,$28
	ld a,(_alt_interrupt_exec)
	ld hl,_alt_interrupt_exec+$27
	add a,(hl)
	add hl,de
	add a,(hl)
	add hl,de
	add a,(hl)
	add hl,de
	add a,(hl)
	add hl,de
	add a,(hl)
	ld (_alt_int_chksum),a

	set alt_int,(iy+exceptionflg)
	ld hl,Static_installed
	jp _puts

; -----

Routine_Location:
.org _alt_interrupt_exec
Routine_Start:

	pop de
	pop hl
	push hl
	push de

	scf		; Set and then compliment the carry
	ccf		; flag, thus clearing it.
	ld de,_asm_exec_ram
	sbc hl,de
	ret c	; Return if pc was less than _asm_exec_ram

	; If you're here, carry flag should theoretically still be cleared...
	ld de,8192
	sbc hl,de	; Add an extra 8k to the subtraction.
	ret nc		; Return if pc was greater than _asm_exec_ram+8k

	ld a,(_asm_exec_ram+8)	; Return if my little key byte was set...
	cp $CE
	ret z

	pop de
	pop hl
	ld hl,Routine_Destroy	; Set program code to continue at Routine_Destroy
							; after the interrupt is complete.
	push hl
	push de
	ret

Routine_Destroy:
	set appTextSave,(iy+appflags)
	call _clrScrn
	call _homeup
	ld hl,Routine_Message
	call _puts
	im 1							; Just in case the program disabled this
	set alt_int,(iy+exceptionflg)	; between now and the last interrupt...
	jp _jforcecmdnochar

Routine_Message:
	.db "Don't play games.",0
Routine_Marker:
	.db $01

Routine_End:
	
; -----

.end
